Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.jpa.support
Class OpenEntityManagerInViewFilter

    java.lang.Object
      org.springframework.web.filter.GenericFilterBean
          org.springframework.web.filter.OncePerRequestFilter
              org.springframework.orm.jpa.support.OpenEntityManagerInViewFilter

All Implemented Interfaces:
  Filter, BeanNameAware, DisposableBean, InitializingBean, ServletContextAware

    public class OpenEntityManagerInViewFilter

extends OncePerRequestFilter

Servlet 2.3 Filter that binds a JPA EntityManager to the thread for the entire processing of the request. Intended for the "Open EntityManager in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

This filter makes JPA EntityManagers available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `JpaTransactionManager` or `JtaTransactionManager` as well as for non-transactional read-only execution.

Looks up the EntityManagerFactory in Spring's root web application context. Supports a "entityManagerFactoryBeanName" filter init-param in `web.xml`; the default bean name is "entityManagerFactory". Looks up the EntityManagerFactory on each request, to avoid initialization order issues (when using ContextLoaderServlet, the root application context will get initialized after this filter).

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  `OpenEntityManagerInViewInterceptor`, `JpaInterceptor`, `JpaTransactionManager`, `JpaTemplate.execute(org.springframework.orm.jpa.JpaCallback)`, `SharedEntityManagerCreator`, `TransactionSynchronizationManager`

Field Summary
`static String` | `DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME`

Fields inherited from class org.springframework.web.filter.OncePerRequestFilter
`ALREADY_FILTERED_SUFFIX`

Fields inherited from class org.springframework.web.filter.GenericFilterBean
`logger`

Constructor Summary
`OpenEntityManagerInViewFilter()`

Method Summary
`protected javax.persistence.EntityManager` | `createEntityManager(javax.persistence.EntityManagerFactory emf)` Create a JPA EntityManager to be bound to a request.
`protected void` | `doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)` Same contract as for `doFilter`, but guaranteed to be just invoked once per request.
`protected String` | `getEntityManagerFactoryBeanName()` Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.
`protected javax.persistence.EntityManagerFactory` | `lookupEntityManagerFactory()` Look up the EntityManagerFactory that this filter should use.
`protected javax.persistence.EntityManagerFactory` | `lookupEntityManagerFactory(HttpServletRequest request)` Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.
`void` | `setEntityManagerFactoryBeanName(String entityManagerFactoryBeanName)` Set the bean name of the EntityManagerFactory to fetch from Spring's root application context.

Methods inherited from class org.springframework.web.filter.OncePerRequestFilter
`doFilter, getAlreadyFilteredAttributeName, shouldNotFilter`

Methods inherited from class org.springframework.web.filter.GenericFilterBean
`addRequiredProperty, afterPropertiesSet, destroy, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setServletContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME

    public static final String DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME

See Also:
  Constant Field Values

Constructor Detail

### OpenEntityManagerInViewFilter

    public OpenEntityManagerInViewFilter()

Method Detail

### setEntityManagerFactoryBeanName

    public void setEntityManagerFactoryBeanName(String entityManagerFactoryBeanName)

  Set the bean name of the EntityManagerFactory to fetch from Spring's root application context. Default is "entityManagerFactory".

  See Also:
    `DEFAULT_PERSISTENCE_MANAGER_FACTORY_BEAN_NAME`

### getEntityManagerFactoryBeanName

    protected String getEntityManagerFactoryBeanName()

  Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.

### doFilterInternal

    protected void doFilterInternal(HttpServletRequest request,
                                    HttpServletResponse response,
                                    FilterChain filterChain)
                             throws ServletException,
                                    IOException

  Description copied from class: `OncePerRequestFilter`
  Same contract as for `doFilter`, but guaranteed to be just invoked once per request. Provides HttpServletRequest and HttpServletResponse arguments instead of the default ServletRequest and ServletResponse ones.

  Specified by:
    `doFilterInternal` in class `OncePerRequestFilter`
  Throws:
    `ServletException`
    `IOException`

### lookupEntityManagerFactory

    protected javax.persistence.EntityManagerFactory lookupEntityManagerFactory(HttpServletRequest request)

  Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.

  Default implementation delegates to the `lookupEntityManagerFactory` without arguments.

  Returns:
    the EntityManagerFactory to use
  See Also:
    `lookupEntityManagerFactory()`

### lookupEntityManagerFactory

    protected javax.persistence.EntityManagerFactory lookupEntityManagerFactory()

  Look up the EntityManagerFactory that this filter should use. The default implementation looks for a bean with the specified name in Spring's root application context.

  Returns:
    the EntityManagerFactory to use
  See Also:
    `getEntityManagerFactoryBeanName()`

### createEntityManager

    protected javax.persistence.EntityManager createEntityManager(javax.persistence.EntityManagerFactory emf)

  Create a JPA EntityManager to be bound to a request.

  Can be overridden in subclasses.

  Parameters:
    `emf` - the EntityManagerFactory to use
  See Also:
    `EntityManagerFactory.createEntityManager()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2007 The Spring Framework.